<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Model;

class Config extends \Magento\Cron\Model\Config
{
    /**
     * @var \Neklo\Scheduler\Model\JobFactory
     */
    private $jobFactory;

    public function __construct(
        \Magento\Cron\Model\Config\Data $configData,
        \Neklo\Scheduler\Model\JobFactory $jobFactory
    ) {
        parent::__construct($configData);
        $this->jobFactory = $jobFactory;
    }

    public function getJobs()
    {
        $jobs = parent::getJobs();
        $coll = $this->jobFactory->create()->getCollection();
        $coll->addFieldToFilter('enabled', true);

        foreach ($coll->getItems() as $item) {
            $jobs[$item->getGroup()][$item->getName()] = $item->getData();
        }

        return $jobs;
    }
}
